/*********************************************************
 *********************************************************/

import java.awt.*;
import java.applet.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;

import netscape.security.PrivilegeManager;

import webwisdom.tango.*;

/**
 * An interactive test of the Graphics.drawArc and Graphics.fillArc
 * routines. Can be run either as a standalone application by
 * typing "java ArcTest" or as an applet in the AppletViewer.
 */

public class ArcTest extends Applet implements TDataListener, TControlListener {

	TAgent agent = null;

	ArcControls controls;

	boolean	Master = true;
	String	MyName = null;

	String	Master_Name;
	String	Participant_Name;
	String	Left_Name;

	int	saved_start;
	int	saved_end;
	int	saved_filled;

	Panel	message = new Panel();
	Label	message1;
	Label	message2;
	Label	message3;
	Label	message4;

	boolean	hasPrivilege = false;

	public  static PrintStream ff1 = null;

	private static String out_file = null;

	public void init() {

		get_privilege();

		act_privilege();

		if (hasPrivilege == false) {
			System.out.println("Necessary privileges have not been granted. Abort.");
			return;
		}

		try {
			agent = new TAgent(new TLAgentApplet(this));
		}
		catch(TangoException e) {
			e.printStackTrace();

		}

		agent.addTDataListener(this);
		agent.addTControlListener(this);
		MyName = agent.getUserName();
		Master = agent.isMaster();

		if (Master) {
			System.out.println("I am master");
			ff1.println("I am master");
		}
		else {
			System.out.println("I am slave");
			String send_data = "Initial";
			agent.send(stringToBytes(send_data));
			ff1.println("I am slave");
		}

		ff1.println("");
		ff1.flush();

		setLayout(new BorderLayout());
		ArcCanvas c = new ArcCanvas();

		// make panel for message
		String blank_string = "                                   ";

		message.setLayout(new GridLayout(4, 1));
		message1 = new Label(blank_string, Label.LEFT);
		message2 = new Label(blank_string, Label.LEFT);
		message3 = new Label(blank_string, Label.LEFT);
		message4 = new Label(blank_string, Label.LEFT);

		message.add(message1);
		message.add(message2);
		message.add(message3);
		message.add(message4);

		update_message();

		add("North", message);
		add("Center", c);
		add("South", controls = new ArcControls(c, this));

	}

	public void start() {

		System.out.println("in start!");
		act_privilege();

		controls.enable();
	}

	public void stop() {
		controls.disable();
		ff1.close();
	}

	public void destroy() {
		ff1.close();
		if (agent != null) {
			agent.exit();
		}
		super.destroy();
	}

	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			System.exit(0);
		}
		return false;
	}

	public void receive(byte b[]) {

		StringTokenizer recv_data = null ;
		boolean filled;
		int filled_int;
		int start;
		int end;

		String r = bytesToString(b);

		System.out.println("receive string" + r);

		// master sends the inital value of filled, start, end
		if (r.startsWith("Initial") && Master) {
			// make one string data to be sent,
			// convert to byte, and send it
			String send_data = saved_filled + 
				" " + saved_start + " " + saved_end;

			agent.send(stringToBytes(send_data));
			return;
		}
		// parse the received String
		recv_data = new StringTokenizer(r);

		filled_int = (Integer.valueOf(recv_data.nextToken())).intValue();
		start      = (Integer.valueOf(recv_data.nextToken())).intValue();
		end        = (Integer.valueOf(recv_data.nextToken())).intValue();

		if ( filled_int == 1 ) {
			filled = true;
		}
		else {
			filled = false;
		}

		controls.draw_canvas(filled, start, end);
		controls.s.setText(String.valueOf(start));
		controls.e.setText(String.valueOf(end));

		update_message();
	}

	private byte[] stringToBytes(String s) {
		int l = s.length();
		byte[] t = new byte[l];
		s.getBytes(0, l, t, 0);
		return t;
	}

	private String bytesToString(byte t[]) {
		return new String(t, 0);
	}

	public void masterChanged(boolean isMaster, String masterName) {
	}

	public void participantJoined(String participantName) {
		Participant_Name = participantName;
		message2.setText("Joint  : " + Participant_Name);
		System.out.println("Join : " + Participant_Name);
	}

	public void participantLeft(String participantName) {
		Left_Name = participantName;
		message3.setText("Left   : " + Left_Name);
		System.out.println("Left : " + Left_Name);
	}

	public void audioRequested(boolean isREquested) {
	}

	public void update_message() {
		System.out.println("update the message!!");
		Master_Name = agent.getMasterName();
		message1.setText("Master : " + Master_Name);
		message2.setText("Joint  : " + Participant_Name);
		message3.setText("Left   : " + Left_Name);
	}

	public void get_privilege() {

/**
		ps.println("Trying to acuire permission to read system properties...");
		try {
			PrivilegeManager.enablePrivilege("UniversalPropertyRead");
			hasPrivilege = true;
			ps.println("\t Success! Privilege is enabled.");
		}
		catch (netscape.security.ForbiddenTargetException e) {
			ps.println("\tFailed! Permission to read system properties denied by user.");
		}
		catch (Exception e) {
			ps.println("\tFailed! Unknown exception while enabling privilege.");
			e.printStackTrace(ps);
		}

		ps.println();
**/

		try {
			PrivilegeManager.enablePrivilege("UniversalFileWrite");
			hasPrivilege = true;
		}
		catch (netscape.security.ForbiddenTargetException e) {
			System.out.println("\tFailed! Permission to read system properties denied by user.");
		}
		catch (Exception e) {
			System.out.println("\tFailed! Unknown exception while enabling privilege.");
		}

	}

	public void act_privilege() {

/**
		if (hasPrivilege == false) {
			ps.println("Necessary privileges have not been granted. Abort.");
			return;
		}

//		read_file(ps);

		PrivilegeManager.enablePrivilege("UniversalPropertyRead");

		String property = "user.home";
		ps.println("Trying to get system property (" + property + ")...");
		try {
			String propertyValue = System.getProperty(property);
			ps.println("\tSuccess!");
			ps.println("\t" + property + " = " + propertyValue);
		}
//		catch (netscape.security.AppletSecurityException e) {
//			ps.println("\tFailed! Security Violation.");
//			e.printStackTrace(ps);
//		}
		catch (Exception e) {
			ps.println("\tFailed! Unknown exception while accessing property.");
			e.printStackTrace(ps);
		}

**/
		if (hasPrivilege == false) {
			System.out.println("Necessary privileges have not been granted. Abort.");
			return;
		}

	PrivilegeManager.enablePrivilege("UniversalFileWrite");

		out_file = "d:\\users\\kimd\\test";
		try {
			FileOutputStream f_out = new FileOutputStream(out_file);
			ff1 = new PrintStream(f_out);

			ff1.println("writing!!!");
		}
		catch(IOException e)
		{
			System.exit(1);
		}

	}
}

class ArcCanvas extends Canvas {
	int	startAngle = 0;
	int	endAngle = 45;
	boolean	filled = false;
	Font	font;

	public void paint(Graphics g) {
		Rectangle r = bounds();
		int hlines = r.height / 10;
		int vlines = r.width / 10;

		g.setColor(Color.pink);
		for (int i = 1; i <= hlines; i++) {
			g.drawLine(0, i * 10, r.width, i * 10);
		}
		for (int i = 1; i <= vlines; i++) {
			g.drawLine(i * 10, 0, i * 10, r.height);
		}

		g.setColor(Color.red);
		if (filled) {
			g.fillArc(0, 0, r.width - 1, r.height - 1, startAngle, endAngle);
		}
		else {
			g.drawArc(0, 0, r.width - 1, r.height - 1, startAngle, endAngle);
		}

		g.setColor(Color.black);
		g.setFont(font);
		g.drawLine(0, r.height / 2, r.width, r.height / 2);
		g.drawLine(r.width / 2, 0, r.width / 2, r.height);
		g.drawLine(0, 0, r.width, r.height);
		g.drawLine(r.width, 0, 0, r.height);
		int sx = 10;
		int sy = r.height - 28;
		g.drawString("S = " + startAngle, sx, sy); 
		g.drawString("E = " + endAngle, sx, sy + 14); 
	}

	public void redraw(boolean filled, int start, int end) {
		this.filled = filled;
		this.startAngle = start;
		this.endAngle = end;
		repaint();
	}
}

class ArcControls extends Panel {
	TextField s;
	TextField e;
	ArcCanvas canvas;
	ArcTest test;

	public ArcControls(ArcCanvas canvas, ArcTest test) {
		this.canvas = canvas;
		this.test = test;
		add(s = new TextField("0", 4));
		add(e = new TextField("45", 4));
		add(new Button("Fill"));
		add(new Button("Draw"));
	}

	public boolean action(Event ev, Object arg) {

		String send_data = null;
		int button_action;
		int int_start;
		int int_end;
		boolean filled;

/**
		// only master can act.
		if (!test.Master) {
			return true;
		}
**/

		if (ev.target instanceof Button) {
			String label = (String)arg;

			filled = label.equals("Fill");
			if (filled) {
				button_action = 1;
			}
			else {
				button_action = 0;
			}

			int_start = Integer.parseInt(s.getText().trim());
			int_end   = Integer.parseInt(e.getText().trim());

			test.saved_start	= int_start;
			test.saved_end		= int_end;
			test.saved_filled	= button_action;

			// make one string data to be sent,
			// convert to byte, and send it
			send_data = button_action + " " + int_start + " " + int_end;

			test.agent.send(stringToBytes(send_data));

			draw_canvas(filled, int_start, int_end);

			test.update_message();

			return true;
		}

		return false;
	}

	private byte[] stringToBytes(String s) {
		int l = s.length();
		byte[] t = new byte[l];
		s.getBytes(0, l, t, 0);
		return t;
	}

	public void draw_canvas(boolean filled, int start, int end) {
		canvas.redraw(filled, start, end);

		test.ff1.println("Filled       : " + filled);
		test.ff1.println("Start Degree : " + start);
		test.ff1.println("Angle        : " + end);
		test.ff1.println("");
		test.ff1.flush();
	}
}

